int SDI = 2;    //数据传输端口
int CLK = 3;    //数据传输时钟
int LOAD = 4;   //数据使能锁存
/****************数码管段码表：共阴**********************/
const u8 Tab[]={0x3f,0x06,0x5b,0x4f,              //0~3
                0x66,0x6d,0x7d,0x07,              //4~7
                0x7f,0x6F,0x77,0x7c,              //8~9  A b 
                0x39,0x5e,0x79,0x71,0x00,0x80};   // C d E F 全灭 .
unsigned char i,j;
void setup()
{
  pinMode(SDI,OUTPUT);    //初始化SDI:输出模式
  pinMode(CLK,OUTPUT);    //初始化CLK:输出模式
  pinMode(LOAD,OUTPUT);   //初始化LOAD:输出模式
}
void SPI_595(unsigned char value)
{
  unsigned char i;
  for(i=0;i<8;i++)  
  {
    digitalWrite(CLK,LOW);                //CLK引脚拉低
    if(0x80&value)                        //判断当前发送数据位
      digitalWrite(SDI,HIGH);             //当前数据位为1，则拉高SDI
    else
      digitalWrite(SDI,LOW);              //当前数据位为0，则拉低SDI
    digitalWrite(CLK,HIGH);               //保存移位数据
    value = value <<1 ;                   //将数据左移一位
  }
  digitalWrite(SDI,LOW);                  //数据输入完毕后复位SDA/CLK
  digitalWrite(CLK,LOW);    
}
void load(void)
{
  digitalWrite(LOAD,HIGH);                 //锁存移位数据并输出
  digitalWrite(LOAD,LOW);                 //完毕后复位LOAD
}

void loop() 
{
  for(i=0;i<18;i++)     //分别依次显示0 1 2...A b ..E F q 全灭 小数点
  {
    for(j=0;j<10;j++)   //串行输入数据，本例程输入10位长度
      SPI_595(Tab[i]); 
    load();             //并行输出
    delay(300);      //延时
  }
}
